// submit.cpp : AvP[Vp̃Gg |Cg̒`
//

#include "stdafx.h"
#include "submit.h"
#include <commctrl.h>
#include "cmd.h"

#define MAX_LOADSTRING 100

// O[oϐ
extern HWND		hwndMain;					// EChEnh
extern TCHAR	szMessage[MAX_LOADSTRING];	// bZ[W

// R}h
CMDCHK_T stCmd[] = {
	{ CMD_NON,	TEXT("nop"),	CmdNop	},
	{ CMD_COPY,	TEXT("copy"),	CmdCopy	},
	{ CMD_DEL,	TEXT("del"),	CmdDel	},
	{ CMD_END,	TEXT("end"),	CmdEnd	},
	{ CMD_MKSCT,TEXT("mksct"),	CmdMksct},
	{ CMD_MOVE,	TEXT("move"),	CmdMove	},
	{ CMD_REM,	TEXT("rem"),	CmdNop	},
	{ CMD_WTREG,TEXT("wtreg"),	CmdWtreg},
	{ CMD_STREG,TEXT("setreg"),	CmdStreg},
	{ CMD_MD,	TEXT("md"),		CmdMd	},
	{ CMD_RD,	TEXT("rd"),		CmdRd	},
	{ CMD_DLREG,TEXT("dlreg"),	CmdDlreg},
	{ CMD_SWOFF,TEXT("swoff"),	CmdPower},
	{ CMD_RESET,TEXT("reset"),	CmdReset},
	{ CMD_MSGBX,TEXT("msgbox"),	CmdMsgbx},
	{ CMD_MSGBX,TEXT("exist"),	CmdExist},
	{ CMD_NON,	NULL,			CmdNop	}
};

// WXg[gL[
struct _REGROOTKEY_T {
	TCHAR	*pName;
	HKEY	hKey;
};
typedef struct _REGROOTKEY_T	REGROOTKEY_T;
REGROOTKEY_T stRegRootKey[] = {
	{ TEXT("HKEY_LOCAL_MACHINE"), HKEY_LOCAL_MACHINE	},
	{ TEXT("HKEY_CLASSES_ROOT"),  HKEY_CLASSES_ROOT		},
	{ TEXT("HKEY_CURRENT_USER"),  HKEY_CURRENT_USER		},
	{ TEXT("HKEY_USERS"),         HKEY_USERS			},
	{ NULL, 0	}
};

// WXg[gL[
struct _REGTYPE_T {
	TCHAR	*pName;
	DWORD	dwType;
};
typedef struct _REGTYPE_T	REGTYPE_T;
REGTYPE_T stRegType[] = {
	{ TEXT("REG_BINARY"),				REG_BINARY				},
	{ TEXT("REG_DWORD"),				REG_DWORD				},
	{ TEXT("REG_DWORD_LITTLE_ENDIAN"),  REG_DWORD_LITTLE_ENDIAN	},
	{ TEXT("REG_DWORD_BIG_ENDIAN"),     REG_DWORD_BIG_ENDIAN	},
	{ TEXT("REG_EXPAND_SZ"),			REG_EXPAND_SZ			},
	{ TEXT("REG_LINK"),					REG_LINK				},
	{ TEXT("REG_MULTI_SZ"),				REG_MULTI_SZ			},
	{ TEXT("REG_NONE"),					REG_NONE				},
	{ TEXT("REG_RESOURCE_LIST"),		REG_RESOURCE_LIST		},
	{ TEXT("REG_SZ"),					REG_SZ					},
	{ NULL, 0	}
};

WORD gwCmdErr = 0;								/* G[R[h */

TCHAR *gpTokenRd = NULL;						/* g[N̓Ǐoʒu */
TCHAR szTokenBuff[MAX_PATH];					/* 擾g[N */

// ֐

TCHAR *GetToken(TCHAR *pPtr)
{
	TCHAR *pwt;									/* P̏ʒu */
	WORD state;									/* Xe[g */
	WORD count;

	if (pPtr != NULL) {							/* obt@w肳ꂽ */
		gpTokenRd = pPtr;						/* ǏoʒuXV */
	}
	if (*gpTokenRd == TEXT('\0')) {				/* obt@Ƀf[^ȂƂ */
		/*puts(".token end");*/
		return NULL;
	}
	pwt = szTokenBuff;
	state = 0;
	count = 0;

	while (*gpTokenRd) {
		if (count >= sizeof(szTokenBuff)-1) {	/* obt@I[o[ */
			break;
		}
		if (state == 0) {						/* 擪Xy[X폜 */
			if ( (*gpTokenRd == TEXT(' ')) || (*gpTokenRd == TEXT('\t')) ) {
				gpTokenRd++;					/* 󔒂𖳎 */
			} else {							/* Xy[XłȂ΂擪 */
				state = 1;
			}
		} else if (state == 1) {				/* Xy[X҂ */
			if ( (*gpTokenRd == TEXT(' ')) || (*gpTokenRd == TEXT('\t')) ) {
				break;
			} else if (*gpTokenRd == TEXT('\"')) {
				state = 3;
			} else {
				*pwt++ = *gpTokenRd;
				count++;
			}
			gpTokenRd++;
		} else if (state == 2) {				/* GXP[v */
			*pwt++ = *gpTokenRd++;
			count++;
			state = 3;
		} else {								/* _uNH[e[V */
			if (*gpTokenRd == TEXT('\"')) {
				state = 1;
			} else if (*gpTokenRd == TEXT('^')) {	/* GXP[v */
				state = 2;
			} else {
				*pwt++ = *gpTokenRd;
				count++;
			}
			gpTokenRd++;
		}
	}
	*pwt = TEXT('\0');							/* g[NI[ */
	return szTokenBuff;
}

void CmdNop(void)
{
	/* Ȃ */
}

void CmdCopy(void)
{
	TCHAR src[MAX_PATH];						// Rs[
	TCHAR dst[MAX_PATH];						// Rs[
	TCHAR *ptr;

	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_COPY << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(src, ptr);
	D(
		wsprintf(szMessage, TEXT("%s"), src);
		MessageBox(hwndMain, szMessage, TEXT("debug copy src"), MB_OK);
	)
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_COPY << 8) | 0x0002;	// Illegal parameter
		return;
	}
	wcscpy(dst, ptr);
	D(
		wsprintf(szMessage, TEXT("%s"), dst);
		MessageBox(hwndMain, szMessage, TEXT("debug copy dst"), MB_OK);
	)
	gwCmdErr = 0;
	BOOL res = CopyFile(src, dst, FALSE);		// ㏑Rs[
	if (res == false) {
		gwCmdErr = (CMD_COPY << 8) | 0x00FF;	// Command error
	}
}

void CmdDel(void)
{
	TCHAR *src;									// 폜Ώ

	src = GetToken(NULL);
	if (src == NULL) {
		gwCmdErr = (CMD_DEL << 8) | 0x0001;		// Illegal parameter
	} else {
		D(
			wsprintf(szMessage, TEXT("%s"), src);
			MessageBox(hwndMain, szMessage, TEXT("debug src"), MB_OK);
		)
		gwCmdErr = 0;
		BOOL res = DeleteFile(src);				// t@C폜
		if (res == false) {
			gwCmdErr = (CMD_DEL << 8) | 0x00FF;	// Command error
		}
	}
}


void CmdEnd(void)
{
	gwCmdErr = 0xFFFF;
}


void CmdMksct(void)
{
	TCHAR src[MAX_PATH];						// 쐬
	TCHAR dst[MAX_PATH];						// 쐬
	TCHAR *ptr;

	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_MKSCT << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(src, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_MKSCT << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(dst, ptr);

	D(
		wsprintf(szMessage, TEXT("%s"), src);
		MessageBox(hwndMain, szMessage, TEXT("debug src"), MB_OK);
		wsprintf(szMessage, TEXT("%s"), dst);
		MessageBox(hwndMain, szMessage, TEXT("debug dst"), MB_OK);
	)
	if (SHCreateShortcut(dst, src) == TRUE) {	// V[gJbg̍쐬
		gwCmdErr = 0;
	} else {
		gwCmdErr = (CMD_MKSCT << 8) | 0x00FF;	// Command error
	}
}


void CmdMove(void)
{
	TCHAR src[MAX_PATH];						// ړ
	TCHAR dst[MAX_PATH];						// ړ
	TCHAR *ptr;

	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_MOVE << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(src, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_MOVE << 8) | 0x0002;	// Illegal parameter
		return;
	}
	wcscpy(dst, ptr);

	gwCmdErr = 0;
	BOOL res = MoveFile(src, dst);				// ړ
	if (res == false) {
		gwCmdErr = (CMD_MOVE << 8) | 0x00FF;	// Command error
	}
}


void CmdWtreg(void)
{
	TCHAR szItem[MAX_LINEBUFF];
	TCHAR rootkey[MAX_PATH];					// [gL[
	TCHAR subkey[MAX_PATH];						// TuL[
	TCHAR name[MAX_PATH];						// ږ
	TCHAR item[MAX_PATH];						// ݒl
	HKEY hRootKey;
	HKEY hKey;
	DWORD dwErr;
	int i;
	int flag;
	TCHAR *ptr;

	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(rootkey, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(subkey, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(name, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(item, ptr);

	D(
		MessageBox(hwndMain, rootkey, TEXT("debug rootkey"), MB_OK);
		MessageBox(hwndMain, subkey, TEXT("debug subkey"), MB_OK);
		MessageBox(hwndMain, name, TEXT("debug name"), MB_OK);
		MessageBox(hwndMain, item, TEXT("debug item"), MB_OK);
	)
	flag = 0;
	for (i=0; stRegRootKey[i].pName != NULL; i++) {
		if (lstrcmp(rootkey, stRegRootKey[i].pName) == 0) {
			hRootKey = stRegRootKey[i].hKey;
			flag = 1;
		}
	}
	if (flag == 0) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0001;	// Illegal parameter
		return;
	}

	if (RegCreateKeyEx(hRootKey, subkey, 
				0, NULL, 0, NULL, NULL, &hKey, &dwErr) != ERROR_SUCCESS) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0002;	// Command error
		return;
	}
	wcscpy(szItem, item);
	D(MessageBox(hwndMain, szItem, TEXT("debug item"), MB_OK);)
	if (RegSetValueEx(hKey, name, 0, REG_SZ, (LPBYTE)szItem, 
				(lstrlen(szItem)+1)*sizeof(TCHAR) ) != ERROR_SUCCESS) {
		gwCmdErr = (CMD_WTREG << 8) | 0x0002;	// Command error
	}

	RegCloseKey(hKey);

	gwCmdErr = 0;
}

// Setreg rootkey subkey name type item
void CmdStreg(void)
{
	TCHAR szItem[MAX_LINEBUFF];
	TCHAR rootkey[MAX_PATH];					// [gL[
	TCHAR subkey[MAX_PATH];						// TuL[
	TCHAR name[MAX_PATH];						// ږ
	TCHAR type[MAX_PATH];						// l̎
	TCHAR item[MAX_LINEBUFF];					// ݒl
	HKEY hRootKey;
	HKEY hKey;
	DWORD dwErr;
	DWORD dwType;
	DWORD dw;
	LONG res;
	int i;
	int flag;
	int len;
	TCHAR *ptr;
	TCHAR *lpOne;

	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_STREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(rootkey, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_STREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(subkey, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_STREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(name, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_STREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(type, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		gwCmdErr = (CMD_STREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(item, ptr);

	D(
		MessageBox(hwndMain, rootkey, TEXT("debug rootkey"), MB_OK);
		MessageBox(hwndMain, subkey, TEXT("debug subkey"), MB_OK);
		MessageBox(hwndMain, name, TEXT("debug name"), MB_OK);
		MessageBox(hwndMain, type, TEXT("debug name"), MB_OK);
		MessageBox(hwndMain, item, TEXT("debug item"), MB_OK);
	)
	flag = 0;
	for (i=0; stRegRootKey[i].pName != NULL; i++) {
		if (lstrcmp(rootkey, stRegRootKey[i].pName) == 0) {
			hRootKey = stRegRootKey[i].hKey;
			flag = 1;
			break;
		}
	}
	if (flag == 0) {
		gwCmdErr = (CMD_STREG << 8) | 0x0002;	// Illegal parameter RootKey
		return;
	}

	flag = 0;
	for (i=0; stRegType[i].pName != NULL; i++) {
		if (lstrcmp(type, stRegType[i].pName) == 0) {
			dwType = stRegType[i].dwType;
			flag = 1;
			break;
		}
	}
	if (flag == 0) {
		gwCmdErr = (CMD_STREG << 8) | 0x0003;	// Illegal parameter Type
		return;
	}

	if (RegCreateKeyEx(hRootKey, subkey, 
				0, NULL, 0, NULL, NULL, &hKey, &dwErr) != ERROR_SUCCESS) {
		gwCmdErr = (CMD_STREG << 8) | 0x0004;	// Command error
		return;
	}
	wcscpy(szItem, item);
	D(MessageBox(hwndMain, szItem, TEXT("debug item"), MB_OK);)

	// WXgւ̐ݒ
	switch (dwType) {
	case REG_BINARY:
	case REG_NONE:
		// item = 00 00 00 00 00
		char data[MAX_PATH];						// ݒl(BINARY)
		i = 0;
		data[i++] = (char)wcstoul(item, NULL, 16);
		while ((ptr = GetToken(NULL)) != NULL) {
			data[i++] = (char)wcstoul(ptr, NULL, 16);
		}
		res = RegSetValueEx(hKey, name, 0, dwType, (LPBYTE)data, i );
		break;

	case REG_DWORD:
	//case REG_DWORD_LITTLE_ENDIAN:
	case REG_DWORD_BIG_ENDIAN:
		// item = 44332211
		dw = (DWORD)wcstoul(item, NULL, 16);
		res = RegSetValueEx(hKey, name, 0, dwType, (LPBYTE)&dw, sizeof(dw) );
		break;

	case REG_EXPAND_SZ:
	case REG_LINK:
	case REG_SZ:
		// item = asciz
		D(MessageBox(hwndMain, szItem, TEXT("debug item"), MB_OK));
		res = RegSetValueEx(hKey, name, 0, dwType, 
				(LPBYTE)szItem, lstrlen(szItem)*sizeof(TCHAR)+2 );
		break;

	case REG_MULTI_SZ:
		// item = asciz asciz
		lpOne = szItem;
		i = lstrlen(szItem);
		lpOne += i;
		lpOne++;					// \0̕
		len = (i + 1) * sizeof(TCHAR);

		while ((ptr = GetToken(NULL)) != NULL) {
			wcscpy(lpOne, ptr);
			i = lstrlen(ptr);
			lpOne += i;
			lpOne++;					// \0̕
			len += (i + 1) * sizeof(TCHAR);
			D(MessageBox(hwndMain, ptr, TEXT("debug item"), MB_OK);)
		}
		*lpOne++ = '\0';					// Ō\0
		len += sizeof(TCHAR);
		res = RegSetValueEx(hKey, name, 0, dwType, (LPBYTE)szItem, len );
		break;

	case REG_RESOURCE_LIST:
		// ? (Ή)
		res = RegSetValueEx(hKey, name, 0, dwType, (LPBYTE)szItem, MAX_LINEBUFF );
		break;

	default:									// NG (ւ͗Ȃ)
		res = ~ERROR_SUCCESS;
		break;
	}
	if (res != ERROR_SUCCESS) {
		gwCmdErr = (CMD_STREG << 8) | 0x0002;	// Command error
	}

	RegCloseKey(hKey);

	gwCmdErr = 0;
}


void CmdDlreg(void)
{
	TCHAR rootkey[MAX_PATH];					// [gL[
	TCHAR subkey[MAX_PATH];						// TuL[
	TCHAR name[MAX_PATH];						// ږ
	HKEY hRootKey;
	HKEY hKey;
	int i;
	int flag;
	TCHAR *ptr;

	ptr = GetToken(NULL);						// [gL[
	if (ptr == NULL) {
		gwCmdErr = (CMD_DLREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(rootkey, ptr);

	ptr = GetToken(NULL);						// TuL[
	if (ptr == NULL) {
		gwCmdErr = (CMD_DLREG << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(subkey, ptr);
	ptr = GetToken(NULL);

	if (ptr == NULL) {							// O
		name[0] = TEXT('\0');					// OȂ̓L[̍폜
	} else {
		wcscpy(name, ptr);						// O͒l̍폜
	}

	D(
		MessageBox(hwndMain, rootkey, TEXT("debug rootkey"), MB_OK);
		MessageBox(hwndMain, subkey, TEXT("debug subkey"), MB_OK);
		MessageBox(hwndMain, name, TEXT("debug name"), MB_OK);
	)

	flag = 0;
	for (i=0; stRegRootKey[i].pName != NULL; i++) {
		if (lstrcmp(rootkey, stRegRootKey[i].pName) == 0) {
			hRootKey = stRegRootKey[i].hKey;
			flag = 1;
		}
	}
	if (flag == 0) {
		gwCmdErr = (CMD_DLREG << 8) | 0x0001;	// Illegal parameter
		return;
	}

	// WXg̃L[J
	if (RegOpenKeyEx(hRootKey, subkey, 0, NULL, &hKey) != ERROR_SUCCESS) {
		gwCmdErr = (CMD_DLREG << 8) | 0x0002;	// Command error
		return;
	}

	if (name[0] == TEXT('\0')) {				// OȂ̏ꍇ
		RegCloseKey(hKey);						// WXg̃L[
		RegDeleteKey(hRootKey, subkey);			// TuL[폜
		D(MessageBox(hwndMain, subkey, TEXT("debug del subkey"), MB_OK);)

	} else {									// Ȍꍇ
		RegDeleteValue(hKey, name);				// l̍폜
		RegCloseKey(hKey);						// WXg̃L[
		D(MessageBox(hwndMain, name, TEXT("debug del value"), MB_OK);)
	}

	gwCmdErr = 0;
}


void CmdExt(TCHAR* pszBuff)
{
	TCHAR cmd[MAX_PATH];
	TCHAR param[MAX_PATH];
	TCHAR *ptr;
	PROCESS_INFORMATION pi;

	ptr = GetToken(pszBuff);
	if (ptr == NULL) {
		gwCmdErr = (CMD_COPY << 8) | 0x0001;	// Illegal parameter
		return;
	}
	wcscpy(cmd, ptr);
	ptr = GetToken(NULL);
	if (ptr == NULL) {
		CreateProcess(cmd, NULL, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
	} else {
		wcscpy(param, ptr);
		CreateProcess(cmd, param, NULL, NULL, FALSE, 0, NULL, NULL, NULL, &pi);
	}
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);

	D(
		MessageBox(hwndMain, cmd, TEXT("debug rootkey"), MB_OK);
		MessageBox(hwndMain, param, TEXT("debug subkey"), MB_OK);
	)

	gwCmdErr = 0;
}

void CmdMd(void)
{
	TCHAR *path;							// tH_

	path = GetToken(NULL);
	if (path == NULL) {
		gwCmdErr = (CMD_MD << 8) | 0x0001;	// Illegal parameter
	}
	D(
		wsprintf(szMessage, TEXT("%s"), path);
		MessageBox(hwndMain, szMessage, TEXT("debug path"), MB_OK);
	)
	if (CreateDirectory(path, NULL)) {
		gwCmdErr = 0;
	} else {
		gwCmdErr = (CMD_MD << 8) | 0x0002;	// Illegal parameter
	}
}

void CmdRd(void)
{
	TCHAR *path;							// tH_

	path = GetToken(NULL);
	if (path == NULL) {
		gwCmdErr = (CMD_RD << 8) | 0x0001;	// Illegal parameter
	}
	D(
		wsprintf(szMessage, TEXT("%s"), path);
		MessageBox(hwndMain, szMessage, TEXT("debug path"), MB_OK);
	)
	if (RemoveDirectory(path)) {
		gwCmdErr = 0;
	} else {
		gwCmdErr = (CMD_RD << 8) | 0x0002;	// Illegal parameter
	}
}


void CmdMsgbx(void)
{
	TCHAR *msg;								// bZ[W

	msg = GetToken(NULL);
	if (msg == NULL) {
		gwCmdErr = (CMD_MSGBX << 8) | 0x0001;	// Illegal parameter
	} else {
		SetCursor(0);
		wcscpy(szMessage, msg);				// bZ[W
		MessageBox(hwndMain, szMessage, TEXT("submit"), MB_OK);
		SetCursor(LoadCursor(NULL, IDC_WAIT));
		gwCmdErr = 0;
	}
}

void CmdExist(void)
{
	TCHAR *fname;								// tpX
	WIN32_FIND_DATA ffd;

	fname = GetToken(NULL);
	if (fname == NULL) {
		gwCmdErr = (CMD_MSGBX << 8) | 0x0001;	// Illegal parameter
	} else {
		D(
			wsprintf(szMessage, TEXT("%s"), fname);
			MessageBox(hwndMain, szMessage, TEXT("debug path"), MB_OK);
		)
		HANDLE hFind = FindFirstFile(fname, &ffd);
		if (hFind != INVALID_HANDLE_VALUE) {	// t@C݂ȂI
			gwCmdErr = 0xFFFF;
		}
	}
}

void CmdPower(void)
{
	keybd_event(VK_OFF, 0, 0, 0);
	keybd_event(VK_OFF, 0, KEYEVENTF_KEYUP, 0);
	gwCmdErr = 0xFFFF;								// I
}


#include <winioctl.h>
extern "C" BOOL KernelIoControl(DWORD dwIoControlCode, LPVOID lpInBuf, DWORD nInBufSize, LPVOID lpOutBuf, DWORD nOutBufSize, LPDWORD lpBytesReturned);
#define IOCTL_HAL_REBOOT CTL_CODE(FILE_DEVICE_HAL, 15, METHOD_BUFFERED, FILE_ANY_ACCESS)
void CmdReset(void)
{
	KernelIoControl(IOCTL_HAL_REBOOT, NULL, 0, NULL, 0, NULL);
}
